# Ha Visual Studio Code-ban dolgozunk:
#   váltsunk át a Python 2.7-es értelmezőre
#   import arcpy

# a következő sor módosítandó:
munkamappa = "s:/Oktatás, tanulás/Oktatás, tanulás 2022_23_2_tavasz/Desktop GIS/gyakorlat/10 Eszközök készítése Pythonnal 2/kimenet"
from arcpy.da import SearchCursor, UpdateCursor, InsertCursor

# DEMO 1
patakok_30 = SearchCursor(
	in_table = "patakok",
	field_names = ["SIZE_CAT", "NAME"],
	where_clause = '"FID" < 30'
)
for sor in patakok_30:
	print("E " + sor[0] + " meretu patak neve " + sor[1] + ".")
del patakok_30

# DEMO 2
with SearchCursor(in_table = "kozeptajak", field_names = ["középtáj", "ter_ha"]) as osszes_kozeptaj:
	for sor in osszes_kozeptaj:
		if sor[1] > 100000:
			print("A(z) " + sor[0] + " azonositoju kozeptaj terulete " + str(sor[1] / 100) + " km2.")
		else:
			print("A(z) " + sor[0] + " azonositoju kozeptaj terulete elhanyagolhato.")

# Feladat 1
patakok_kicsi = SearchCursor(
	in_table = "patakok",
	field_names = ["FID", "NAME"],
	where_clause = """"SIZE_CAT" = 'kicsi'"""
)
for sor in patakok_kicsi:
	if sor[0] % 100 == 0:
		print("A(z) " + str(sor[0]) + " azonositoju kicsi patak neve " + sor[1] + ".")
del patakok_kicsi

# DEMO 3
arcpy.management.CopyFeatures(
	in_features = "kozeptajak",
	out_feature_class = munkamappa + "/kozaptajak_masolat.shp"
)
kozeptajak_rovid = UpdateCursor(
	in_table = munkamappa + "/kozaptajak_masolat.shp",
	field_names = ["FID", "középtá", "ter_ha"], # átneveződött középtáj-ról középtá-ra...
	where_clause = '"Shape_Leng" < 300000'
)
for sor in kozeptajak_rovid:
	if sor[0] < 5:
		print("A(z) " + str(sor[0]) + " azonositoju kozeptaj teruletet modositom.")
		modositott_sor = sor # masolatot hoz letre (folosleges, lehet helyben is dolgozni)
		modositott_sor[2] = modositott_sor[0] * 10000
		kozeptajak_rovid.updateRow(modositott_sor)
	elif sor[1][0] == "C": # C betuvel kezdodik
		print("A(z) '" + sor[1] + "' nevu kozeptajat torlom.")
		kozeptajak_rovid.deleteRow()
	else:
		print("A(z) '" + sor[1] + "' nevu kozeptajjal nem csinalok semmit.")
del kozeptajak_rovid

# DEMO 4: cellaerteketCserel.py

# Feladat 2
arcpy.management.CopyFeatures(
	in_features = "patakok",
	out_feature_class = munkamappa + "/patakok_masolat.shp"
)
patakok_Drava = UpdateCursor(
	in_table = munkamappa + "/patakok_masolat.shp",
	field_names = ["SIZE_CAT", "NAME"],
	where_clause = """"NAME" LIKE 'Dráva%'"""
)
for sor in patakok_Drava:
	if sor[0] == " ": # ha ismeretlen (egy szóköz) a patak mérete
		sor[0] = "kozepes"
		print("A '" + sor[1] + "' nevu patak meretet megadom.")
		patakok_Drava.updateRow(sor)
	else:
		print("A '" + sor[1] + "' nevu patakot torlom.")
		patakok_Drava.deleteRow()
del patakok_Drava

# DEMO 5
from arcpy.sa import *
k = 2 * 2 # számművelet: 4
print(k)
x = "cserhat" * 2 # szövegismétlés: "cserhatcserhat"
print(x)
x = Raster("cserhat") * 2 # cellaértékek kétszerezése
print(x)
x.save(munkamappa + "/cserhat_dupla.tif")
raszterszorzat = Raster("cserhat") * Raster("okoszisztema") # cellánkénti összeszorzás

# DEMO 6
okoszisztema = Raster("okoszisztema")
alacsony_beepites = okoszisztema == 1110
magas_beepites = okoszisztema == 1120
telepules = alacsony_beepites | magas_beepites
meredekseg = Slope(in_raster = "pilis", output_measurement = "DEGREE")
meredekseg_telepulesen = telepules * meredekseg
cserhat_magas = Raster("cserhat") > 300
max_kategoria = ZonalStatistics(in_zone_data = cserhat_magas, zone_field = "Value", in_value_raster = okoszisztema, ignore_nodata = True, statistics_type = "MAXIMUM")

# Feladat 3
kitoltott = Fill(in_surface_raster = "cserhat")
lefolyasi_irany = FlowDirection(in_surface_raster = kitoltott)
vizgyujto = Basin(in_flow_direction_raster = lefolyasi_irany)
vizgyujto.save(munkamappa + "/cserhat_dupla.tif")
arcpy.conversion.RasterToPolygon(in_raster = vizgyujto, out_polygon_features = munkamappa + "/vizgyujto.shp", simplify = True)

# Feladat 4
okoszisztema = Raster("okoszisztema")
tavolsag = EucDistance(in_source_data = okoszisztema)
tavolsag_km = tavolsag / 1000
messzi = tavolsag_km > 10
messzi.save(munkamappa + "/messzi.tif")

# Feladat 5
kitettseg = Aspect(in_raster = "pilis")
okoszisztema_aggr = Aggregate(in_raster = "okoszisztema", cell_factor = 20, aggregation_type = "MINIMUM", ignore_nodata = False)
kitettseg_maszkolt = ExtractByMask(in_raster = kitettseg, in_mask_data = okoszisztema_aggr)

# Feladat 6
cserhat_paros = Raster("cserhat") % 2 == 0
arcpy.management.Resample(in_raster = "okoszisztema", out_raster = munkamappa + "/okoszisztema_ujramintavetelezett.tif", cell_size = 1000, resampling_type = "MAJORITY")
okoszisztema_ujramintavetelezett = Raster(munkamappa + "/okoszisztema_ujramintavetelezett.tif")
arcpy.conversion.RasterToPoint(in_raster = okoszisztema_ujramintavetelezett, out_point_features = munkamappa + "/okoszisztema_ujramintavetelezett.shp")
ExtractValuesToPoints(in_point_features = munkamappa + "/okoszisztema_ujramintavetelezett.shp", in_raster = cserhat_paros, out_point_features = munkamappa + "/okoszisztema_ujramintavetelezett_paros.shp")

# Feladat 7
cserhat = Raster("cserhat")
cserhat = cserhat * 3
cserhat_lejtoszazalek = Slope(in_raster = cserhat, output_measurement = "PERCENT_RISE")
cserhat_lejtoszazalek_elkent = FocalStatistics(in_raster = cserhat_lejtoszazalek, statistics_type = "MEAN")
cserhat_lejtoszazalek_25 = Aggregate(in_raster = cserhat_lejtoszazalek_elkent, cell_factor = 5, aggregation_type = "MEAN", ignore_nodata = True)
cserhat_lejtoszazalek_25.save(munkamappa + "/cserhat_lejtoszazalek_25.tif")

# Feladat 8
pilis = Raster("pilis")
pilis = pilis + 1000
Contour(in_raster = pilis, out_polyline_features = munkamappa + "/pilis_szintvonalak.shp", contour_interval = 100, base_contour = 0)
lefolyas = FlowDirection(in_surface_raster = pilis)
arcpy.conversion.RasterToPolygon(in_raster = lefolyas, out_polygon_features = munkamappa + "/lefolyas.shp", simplify = False)
